--  Awesome Tower Defense
--  Copyright (C) 2008-2009  Trygve Vea and contributors (read AUTHORS)
--  Copyright (C) 2010 Sean Bolton
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License along
--  with this program; if not, write to the Free Software Foundation, Inc.,
--  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

cell_x = 0
cell_y = 0

local cursor = {}
cursor.inited = false

function init_cursor()
    --cursor.surface = SDL.CreateRGBSurface(ubit.bor(SDL.SWSURFACE, SDL.SRCALPHA), RECTSIZE_X * 2, RECTSIZE_Y, 32, 0, 0, 0, 0)
    cursor.surface = load_surface_from_file("cursor.png")
    cursor.surface = cursor.surface:DisplayFormat()
    cursor.srect = SDL.newRect( 0, 0, RECTSIZE_X, RECTSIZE_Y )
    --cursor.surface:FillRect(cursor.srect, SDL.MapRGB_using_Surface(cursor.surface, 255,0,0))
    cursor.drect = SDL.newRect( RECTSIZE_X, 0, RECTSIZE_X, RECTSIZE_Y )
    --cursor.surface:FillRect(cursor.drect, SDL.MapRGB_using_Surface(cursor.surface, 0,255,0))
    cursor.surface:SetAlpha(ubit.bor(SDL.SRCALPHA, SDL.RLEACCEL), 112) -- 128 work on linux?
    cursor.would_block_x = -1
    cursor.would_block_y = -1
    cursor.would_block_ticks = -2000
    cursor.inited = true
end

function update_cursor(x, y)
    local old_x, old_y = cell_x, cell_y
    cell_x = math.floor(x / RECTSIZE_X)
    cell_y = math.floor(y / RECTSIZE_Y)
    if current_screen == SCREEN_INGAME then
        updaterect(old_x, old_y)
        updaterect(cell_x,cell_y)
    end
end

function set_cursor_would_block(x, y)
    cursor.would_block_x = x
    cursor.would_block_y = y
    cursor.would_block_ticks = SDL.GetTicks() + 3000
    updaterect(x, y)
end

-- void draw_cursor(SDL_Surface *s) {
function draw_cursor(s)
    if not cursor.inited then init_cursor() end
    if cell_x > 0 and cell_x < 19 and cell_y > 0 and cell_y < 13 then
        local n = 0
        -- -FIX- this should also show red if player does not have enough money
        if map:tower_allowed(cell_x, cell_y) and not has_monster(cell_x, cell_y) then
            if cursor.would_block_ticks > SDL.GetTicks() and
               cursor.would_block_x == cell_x and
               cursor.would_block_y == cell_y then
                n = 2 -- show "WOULD BLOCK"
            else
                n = 1 -- show green
            end
        end
        SDL.setRect( cursor.srect, n * RECTSIZE_X, 0, RECTSIZE_X, RECTSIZE_Y )
        SDL.setRect( cursor.drect, cell_x*RECTSIZE_X, cell_y*RECTSIZE_Y, RECTSIZE_X, RECTSIZE_Y )
        SDL.BlitSurface(cursor.surface, cursor.srect, s, cursor.drect)
    end
end
