--  Awesome Tower Defense
--  Copyright (C) 2008-2009  Trygve Vea and contributors (read AUTHORS)
--  Copyright (C) 2010 Sean Bolton
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License along
--  with this program; if not, write to the Free Software Foundation, Inc.,
--  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

buttonsurface = nil -- SDL_Surface *
buttonsurface2 = nil -- SDL_Surface *
-- static SDL_Rect button_rects[3] = {  -- indexed from 0
button_rects = nil
-- static SDL_Rect button_rects2[7] = {  -- indexed from 0
button_rects2= nil

button_count = 3
button2_count = 7
towerbutton = 0
button2tooltip = -1
button_pressed = -1
-- static const char buttonhint[3][40] = {  -- indexed from 1
buttonhint = {
    "build pillbox",
    "build artificial volcano",
    "build freezer"
}
-- static const char buttonhint2[7][33] = {  -- indexed from 1
buttonhint2 = {
    "sell tower                     ",
    "shoot enemy travelled the least",
    "shoot enemy travelled farthest ",
    "shoot enemy with most hp       ",
    "shoot enemy with least hp      ",
    "shoot the fastest enemy        ",
    "toggle shooting                "
}

function update_tooltip(x, y)
    local newtip = -1
    for i = 0, button2_count - 1 do
        local rx, ry, rw, rh = SDL.getRect(button_rects2[i])
        if x > rx and x < (rx+rw) and y > ry and y < (ry+rh) then
            newtip = i
            break
        end
    end
    if button2tooltip ~= newtip then
        for i = 8, 16 do
            updaterect(i, 0)
        end
    end
    button2tooltip = newtip
end

-- void init_buttons(void) {
function init_buttons()
    button_rects = {}
    button_rects[0] = SDL.newRect( 260, 430, 48, 48 )
    button_rects[1] = SDL.newRect( 308, 430, 48, 48 )
    button_rects[2] = SDL.newRect( 356, 430, 48, 48 )
    button_rects2 = {}
    button_rects2[0] = SDL.newRect( 256, 8, 24, 24 )
    button_rects2[1] = SDL.newRect( 304, 8, 24, 24 )
    button_rects2[2] = SDL.newRect( 328, 8, 24, 24 )
    button_rects2[3] = SDL.newRect( 352, 8, 24, 24 )
    button_rects2[4] = SDL.newRect( 376, 8, 24, 24 )
    button_rects2[5] = SDL.newRect( 400, 8, 24, 24 )
    button_rects2[6] = SDL.newRect( 448, 8, 24, 24 )

    -- buttonsurface = SDL_LoadBMP_RW(SDL_RWFromMem(&_binary_buttonbar_bmp_start,0x0000d836),0);
    buttonsurface = load_surface_from_file("buttonbar.bmp"):DisplayFormat()
    -- buttonsurface2 = SDL_LoadBMP_RW(SDL_RWFromMem(&_binary_buttonbar2_bmp_start,0x00007e36),0);
    buttonsurface2 = load_surface_from_file("buttonbar2.bmp"):DisplayFormat()
end

-- void draw_buttons(SDL_Surface *s) {
function draw_buttons(s)
    local rect = SDL.newRect() -- { 0,0,48,48 }
    for i = 0, button_count - 1 do
        local rx
        if button_pressed == i then rx = 48 else rx = 0 end
        SDL.setRect(rect, rx, i * 48, 48, 48)
        SDL.BlitSurface(buttonsurface, rect, s, button_rects[i])
    end
end

-- void draw_buttons2(SDL_Surface *s) {
function draw_buttons2(s)
    local rect = SDL.newRect() -- { 0,0,24,24 }

    if selected_tower == 0 then return end

    if button2tooltip > -1 then draw_text(screen, buttonhint2[button2tooltip + 1], 256,0 )
    else draw_text(screen, "                                 ", 256, 0 ) end

    for i = 0, button2_count - 1 do
        local rx
        if i < 6 then
            if towers[selected_tower].target_algorithm == i then rx = 24 else rx = 0 end
        elseif i == 6 then
            if towers[selected_tower].paused then rx = 24 else rx = 0 end
        end
        SDL.setRect(rect, rx, i * 24, 24, 24)
        SDL.BlitSurface(buttonsurface2, rect, s, button_rects2[i])
    end
end

function press_buttonnumber(i) -- i is 1 to 3
    towerbutton = ((i-1)*3)
    costtext = string.format("%6d", tower_definition(towerbutton).price)
    if button_pressed ~= -1 then
        updateextent(SDL.getRect(button_rects[button_pressed])) -- update previously selected button
    end
    button_pressed = i - 1
    updateextent(SDL.getRect(button_rects[button_pressed])) -- update newly selected button
    for x = 8, 15 do
        updaterect(x, 13) -- update cost text and hint text
    end
end

-- void press_button(int x, int y) {
function press_button(x, y)
    for i = 0, button_count - 1 do
        local rx, ry, rw, rh = SDL.getRect(button_rects[i])
        if x <= (rx + rw) and x >= rx and y >= ry and y <= (ry + rh) then
            press_buttonnumber(i + 1)
            return
        end
    end
    for i = 0, button2_count - 1 do
        local rx, ry, rw, rh = SDL.getRect(button_rects2[i])
        if x <= (rx + rw) and x >= rx and y >= ry and y <= (ry + rh) then
            if i == 0 then sell_tower(selected_tower)
            elseif i == 6 then toggle_shooting(selected_tower)
            else tower_algorithm(selected_tower, i)
            end
            for i = 8, 14 do
                updaterect(i,0)  -- -FIX- this ought to be done in sell_tower(), toggle_shooting(), and tower_algorithm(), but it's currently buggy
            end
            return
        end
    end
end

-- void draw_hint_text(SDL_Surface *s) {
function draw_hint_text(s)
    if button_pressed ~= -1 then
        draw_text(s, buttonhint[button_pressed + 1], 320, 416)
    else
        draw_text(s, "                        ", 320, 416)
    end
end

