--  Awesome Tower Defense
--  Copyright (C) 2008-2009  Trygve Vea and contributors (read AUTHORS)
--  Copyright (C) 2010 Sean Bolton
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License along
--  with this program; if not, write to the Free Software Foundation, Inc.,
--  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

CHAR_SIZE_X = 8
CHAR_SIZE_Y = 8

charmap_inited = false

charmapsurface = nil -- SDL_Surface *

function init_gfx_charmap()
    local tempsurface = load_surface_from_file("font.bmp")
    local w, h = tempsurface:getSize()
    charmapsurface = SDL.CreateRGBSurface(SDL.SWSURFACE, w, h, 8, 255, 255, 255, 0)
    SDL.BlitSurface(tempsurface, nil, charmapsurface, nil)
    charmap_inited = true
end

-- void draw_text(SDL_Surface *s, const char *text, int x, int y) {
function draw_text(s, text, x, y)
    if not charmap_inited then init_gfx_charmap() end
    local srcrect = SDL.newRect()
    local dstrect = SDL.newRect()
    for i = 0, #text - 1 do
        local c = string.byte(text, i + 1) - 32
        if c < 0 or c > 95 then c = 95 end
        SDL.setRect(srcrect, c * CHAR_SIZE_X, 0,CHAR_SIZE_X,CHAR_SIZE_Y)
        SDL.setRect(dstrect, x + i * CHAR_SIZE_X, y, CHAR_SIZE_X, CHAR_SIZE_Y)
        SDL.BlitSurface(charmapsurface, srcrect, s, dstrect)
    end
end

-- void draw_text_color(SDL_Surface *s, const char *text, int x, int y, int r, int g, int b) {
function draw_text_color(s, text, x, y, r, g, b)
    if not charmap_inited then init_gfx_charmap() end
    local fontcolor = SDL.MapRGB_using_Surface(charmapsurface, 255, 255, 255)
    local color = SDL.newColor(r, g, b)
    charmapsurface:SetPalette1(SDL.LOGPAL, color, fontcolor)
    draw_text(s,text,x,y)
    color = SDL.newColor(255, 255, 255)
    charmapsurface:SetPalette1(SDL.LOGPAL, color, fontcolor)
end

