--  Awesome Tower Defense
--  Copyright (C) 2008-2009  Trygve Vea and contributors (read AUTHORS)
--  Copyright (C) 2010 Sean Bolton
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License along
--  with this program; if not, write to the Free Software Foundation, Inc.,
--  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

MAX_OPTIONS = 5

-- static char options[MAX_OPTIONS][12] = {
options = {
    "new game",
    "high scores",
    "tutorial",
    "credits",
    "quit"
}

selected = 0

function draw_menu()
    local ypos = 200
    for i = 0, MAX_OPTIONS - 1 do
        if i == selected then
            draw_text_color(screen,options[i + 1],400,ypos,255,255,0)
        else
            draw_text_color(screen,options[i + 1],400,ypos,255,255,255)
        end
        ypos = ypos + 16
    end
    -- -FIX- hack level selection code
    ypos = 200
    for i = 1, #levels do
        local desc = string.format("level %d", i)
        if levels[i].description then
            desc = desc .. " - " .. levels[i].description
        end
        if i == currentlevel then
            draw_text_color(screen,desc,16,ypos,255,255,0)
        else
            draw_text_color(screen,desc,16,ypos,255,255,255)
        end
        ypos = ypos + 16
    end
end

function click_menu()
    if selected == 0 then
        new_game()
    elseif selected == 1 then
        show_highscores(SCORE_NOMESSAGE)
    elseif selected == 2 then
        show_tutorial()
    elseif selected == 3 then
        show_credits()
    elseif selected == 4 then
        return true
    end
    return false
end

function update_menu_selection(x, y)
    local oldselected = selected
    if x >= 400 and x <= 488 and y >= 200 and y < (200 + (MAX_OPTIONS * 16)) then
        selected = math.floor((y - 200) / 16)
        if oldselected ~= selected then
            updateextent(400, 200, 96, 89)
        end
    end
    -- -FIX- hack level selection code
    local oldcurrent = currentlevel
    if x >= 16 and x < 400 and y >= 200 and y < (200 + (#levels * 16)) then
        currentlevel = math.floor((y - 200) / 16) + 1
        if oldcurrent ~= currentlevel then
            updateextent(16, 200, 384, #levels * 16)
            selected = 0
            updateextent(400, 200, 96, 89)
        end
    end
end

function show_menu()
    current_screen = SCREEN_MENU
    game_paused = false
    update_all()
end
