--  Awesome Tower Defense
--  Copyright (C) 2008-2009  Trygve Vea and contributors (read AUTHORS)
--  Copyright (C) 2010 Sean Bolton
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License along
--  with this program; if not, write to the Free Software Foundation, Inc.,
--  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

hoverchoice = 0
tutorials = {
    "basic gameplay",
    "upgrading towers",
    "targetting algorithm",
    "hotkeys"
}
redraw = true
function show_tutorial()
    current_screen = SCREEN_TUTORIAL
    redraw = true
end

sprites_loaded = false

tut_basic = nil -- SDL_Surface *
tut_basic_rect = nil -- SDL_Rect
tut_upgrading = nil -- SDL_Surface *
tut_upgrading_rect = nil -- SDL_Rect

function load_sprites()
    tut_basic_rect = SDL.newRect( 200,160,144,128 )
    tut_upgrading_rect = SDL.newRect( 480,160,144,128 )
    tut_basic = load_surface_from_file("tut_basic.bmp"):DisplayFormat()
    tut_upgrading = load_surface_from_file("tut_upgrading.bmp"):DisplayFormat()
    print("sprites loaded!")
    sprites_loaded = true
end

function draw_tutorial()
    if not sprites_loaded then load_sprites() end

    if not redraw then return end

    update_all()

    for i = 0, 3 do
        if hoverchoice ~= i then draw_text(screen,tutorials[i + 1],16,160+(i*16))
        else draw_text_color(screen,tutorials[i + 1],16,160+(i*16),255,255,0) end
    end

    if hoverchoice == 0 then
                            --#################################
                            --#####################################################
            SDL.BlitSurface(tut_basic, nil, screen, tut_basic_rect)
            draw_text(screen,"enemies will move down a road, if",360,160)
            draw_text(screen,"they don't get killed before they",360,176)
            draw_text(screen,"get to the end you lose a life.",360,192)
            draw_text(screen,"the goal is to survive all the",360,208)
            draw_text(screen,"upcoming waves of enemies. when",360,224)
            draw_text(screen,"you kill an enemy, you recieve",360,240)
            draw_text(screen,"money and points for each kill.",360,256)
            draw_text(screen,"the amount of money you get only",360,272)
            draw_text(screen,"depend on the enemy you kill.",360,288)
            draw_text(screen,"the amount of points you get depend on how far the",200,304)
            draw_text(screen,"enemy have travelled along the route. earlier kill",200,320)
            draw_text(screen,"means more points.",200,336)
    elseif hoverchoice == 1 then
                            --#################################
                            --#####################################################
            SDL.BlitSurface(tut_upgrading, nil, screen, tut_upgrading_rect)
            draw_text(screen,"when a tower makes a killing blow",200,160)
            draw_text(screen,"it earns experience. the yellow",200,176)
            draw_text(screen,"bar indicates how far it is from",200,192)
            draw_text(screen,"an upgrade. when a tower is fully",200,208)
            draw_text(screen,"upgraded it will not gain more",200,224)
            draw_text(screen,"experience. the killing blow goes",200,240)
            draw_text(screen,"to the last upgradeable tower who",200,256)
            draw_text(screen,"made a hit on the enemy. the",200,272)
            draw_text(screen,"trick is to position the towers",200,288)
            draw_text(screen,"in a way that makes sure that as little experience",200,304)
            draw_text(screen,"as possible are wasted.",200,320)
    elseif hoverchoice == 2 then
                            --#################################
                            --#####################################################
            local tower_dst = SDL.newRect()
            local tower_src = SDL.newRect()
            local dy, sy
            draw_text(screen,"you can control how the towers determine which target",200,160)
            draw_text(screen,"to aim for. when you click a tower, a row of buttons",200,176)
            draw_text(screen,"will appear on the top of the screen. the buttons let",200,192)
            draw_text(screen,"you pick between 5 algorithms:",200,208)

            dy = 232; sy = 24
            SDL.setRect(tower_dst, 200, dy, 24, 24)
            SDL.setRect(tower_src, 0, sy, 24, 24)
            SDL.BlitSurface(buttonsurface2, tower_src, screen, tower_dst)
            draw_text(screen,"shoot enemy travelled the least",232,240)

            dy = dy + 32; sy = sy + 24
            SDL.setRect(tower_dst, 200, dy, 24, 24)
            SDL.setRect(tower_src, 0, sy, 24, 24)
            SDL.BlitSurface(buttonsurface2, tower_src, screen, tower_dst)
            draw_text(screen,"shoot enemy travelled the farthest",232,272)

            dy = dy + 32; sy = sy + 24
            SDL.setRect(tower_dst, 200, dy, 24, 24)
            SDL.setRect(tower_src, 0, sy, 24, 24)
            SDL.BlitSurface(buttonsurface2, tower_src, screen, tower_dst)
            draw_text(screen,"shoot enemy with most hp",232,304)

            dy = dy + 32; sy = sy + 24
            SDL.setRect(tower_dst, 200, dy, 24, 24)
            SDL.setRect(tower_src, 0, sy, 24, 24)
            SDL.BlitSurface(buttonsurface2, tower_src, screen, tower_dst)
            draw_text(screen,"shoot enemy with least hp",232,336)

            dy = dy + 32; sy = sy + 24
            SDL.setRect(tower_dst, 200, dy, 24, 24)
            SDL.setRect(tower_src, 0, sy, 24, 24)
            SDL.BlitSurface(buttonsurface2, tower_src, screen, tower_dst)
            draw_text(screen,"shoot the fastest enemy",232,368)
    elseif hoverchoice == 3 then
                draw_text_color(screen,"1",232,160,0,255,255)
            draw_text(screen,"build pillbox",280,160)
                draw_text_color(screen,"2",232,176,0,255,255)
            draw_text(screen,"build artificial volcano",280,176)
                draw_text_color(screen,"3",232,192,0,255,255)
            draw_text(screen,"build freezer",280,192)
                draw_text_color(screen,"s",232,208,0,255,255)
            draw_text(screen,"sell tower",280,208)
                draw_text_color(screen,"q",232,224,0,255,255)
            draw_text(screen,"shoot enemy travelled the least",280,224)
                draw_text_color(screen,"w",232,240,0,255,255)
            draw_text(screen,"shoot enemy travelled the farthest",280,240)
                draw_text_color(screen,"e",232,256,0,255,255)
            draw_text(screen,"shoot enemy with most hp",280,256)
                draw_text_color(screen,"r",232,272,0,255,255)
            draw_text(screen,"shoot enemy with least hp",280,272)
                draw_text_color(screen,"t",232,288,0,255,255)
            draw_text(screen,"shoot the fastest enemy",280,288)
                draw_text_color(screen,"p",232,304,0,255,255)
            draw_text(screen,"pause tower",280,304)

                draw_text_color(screen,"f",232,320,0,255,255)
            draw_text(screen,"toggle fast mode",280,320)

                draw_text_color(screen,"space",232,336,0,255,255)
            draw_text(screen,"pause the game",280,336)
                draw_text_color(screen,"esc",232,352,0,255,255)
            draw_text(screen,"quit to menu",280,352)
    end
    redraw = false
end

-- void update_tutorial_selection(int x, int y) {
function update_tutorial_selection(x, y)
    local oldchoice = hoverchoice
    if x >= 16 and x <= 176 and y >= 160 and y < (160+(16*4)) then
        hoverchoice = math.floor((y-160)/16)
    end
    if oldchoice ~= hoverchoice then
        redraw = true
    end
end

